# decoration.sql was originally generated by the autoSql program, which also 
# generated decoration.c and decoration.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Browser extensible data (12 fields) plus information about what item this decorates and how.
CREATE TABLE decoration (
    chrom varchar(255) default '',	# Chromosome (or contig, scaffold, etc.)
    chromStart int unsigned default 0,	# Start position in chromosome
    chromEnd int unsigned default 0,	# End position in chromosome
    name varchar(255) default '',	# Name of item
    score int unsigned default 0,	# Score from 0-1000
    strand char(1) default '',	# + or -
    thickStart int unsigned default 0,	# Start of where display should be thick (start codon)
    thickEnd int unsigned default 0,	# End of where display should be thick (stop codon)
    color int unsigned default 0,	# Primary RGB color for the decoration
    blockCount int default 0,	# Number of blocks
    blockSizes longblob,	# Comma separated list of block sizes
    chromStarts longblob,	# Start positions relative to chromStart
    decoratedItem varchar(255) default '',	# Identity of the decorated item in chr:start-end:item_name format
    style varchar(255) default '',	# Draw style for the decoration (e.g. block, glyph)
    fillColor varchar(255) default '',	# Secondary color to use for filling decoration, blocks, supports RGBA
    glyph varchar(255) default '',	# The glyph to draw in glyph mode; ignored for other styles
              #Indices
    PRIMARY KEY(chrom)
);
